<?php
/* StuPa-O-Mat
 * Copyright (C) by Andrea Oster, 2010
 * This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License, Version 2, as published by the Free Software Foundation.

 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA 

 */
?>
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=utf-8" />
<style type="text/css">
body{text-align:center;border:1px solid black;width:840px; position:absolute; margin-left:80px;margin-top:80px;}
table{max-width:800px;margin-left:20px;}
td{border: 0.0px solid black; border-collapse:collapse; min-width:55px; font:10pt sans-serif;border-bottom: 0.1px solid black;border-left:0.1px dotted black;}
td.vote-pos{background:green;width:54px;text-align:center;}
td.vote-neg{background:red;width:54px;text-align:center;}
td.vote-neu{background:yellow;width:54px;text-align:center;}
td.barchart_blue{height:50px;width:3.3px;height:10px;background:#183a8d;min-width:2px;}
</style>
</head>
<body>
<h1>StuPa-O-Mat für die StuPa-Wahl 2010</h1> 
<hr/>
<?php
//Globale Konstanten

//Antworten der HSGs in the_content.php
include("the_content.php");

//Globale Ende
function VoteToTableLink($x,$link){
	if($x=="Ja")
		$str="<td class='vote-pos'><a href='". $link  . "' target='_blank'>+</a></td>";
	else if($x=="Nein")
		$str="<td class='vote-neg'><a href='" . $link  . "' target='_blank'>-</a></td>";
	else 	$str="<td class='vote-neu'><a href='" . $link  . "' target='_blank'>o</a></td>";
	return $str;
}
function VoteToTable($x){
	if($x=="Ja")
		$str="<td class='vote-pos'>+</td>";
	else if($x=="Nein")
		$str="<td class='vote-neg'>-</td>";
	else 	$str="<td class='vote-neu'>o</td>";
	return $str;
}
function percentGraph($input){
	if($input<0 || $input>100) return;
	for($a=1;$a<=$input;$a++){
		echo "<td class='barchart_blue'></td>";
	}
	for($a=1;$a<=100-$input;++$a)
		echo "<td style='min-width:2px;'></td>";
}

if(!isset($_POST["question"])) $step=1;
else $step=intval($_POST["question"]);

if ($step==$QUESTION_NUMBER+1){//Gewichtung festlegen
	echo "<h2>Gewichtung</h2>";	
	echo "<form method='post' action='stupaomat.php'><table align='center'>";
	for($i=0;$i<$QUESTION_NUMBER;++$i){
		echo "<tr><td>". $stichw[$i] . "</td>";
		//echo "<td><input type='radio' name='gew". ($i+1)  . "' value='eins' enabled='enabled'/>Einfach</td>"; 
		echo "<td><input type='checkbox' name='gew". ($i+1)  . "' value='zwei'/>Doppelt</td>"; 
		//echo "<td><input type='radio' name='gew". ($i+1)  . "' value='drei'/>Dreifach</td></tr>";
	}

	for ($i=1;$i<=$QUESTION_NUMBER;++$i){
		 // schleife Antworten durch
		if(isset($_POST['a'.$i])){
?>
		<input type="hidden" name="a<?php echo $i;?>" value="<?php echo htmlspecialchars($_POST['a'.$i])?>"/>
<?php
		}
	}
	echo "</table><input type='hidden' name='question' value='" . ($QUESTION_NUMBER+2) . "' />";
	echo "<button type='submit' style='background:yellow;font-style:italic;font-size: 12pt;font-family:serif;'>Zur Auswertung</span></button>";
	echo "</form>";

}

else if($step>$QUESTION_NUMBER+1){//fertig, an die auswertung
	echo "<h2> Auswertung </h2>";
	global $user,$gew;
	for($i=0;$i<$QUESTION_NUMBER;++$i){
		if(isset($_POST['a'.($i+1)]))
			$user[$i]=$_POST['a'.($i+1)];
		else 	$user[$i]="Egal";
	}
	$extra_gew_summe=0;
	for($i=0;$i<$QUESTION_NUMBER;++$i){
		if(isset($_POST['gew'.($i+1)])){
			$tmp=$_POST['gew'.($i+1)];
			if($tmp=="zwei") {$gew[$i]=2;$extra_gew_summe+=1;}
			else if($tmp=="drei") {$gew[$i]=3;$extra_gew_summe+=2;}
			else $gew[$i]=1;
		}
		else $gew[$i]=1;
	}

	global $res;
	foreach($pos as $posKey => $x){
		$res=0.0;
		$q_no=$QUESTION_NUMBER+$extra_gew_summe;
		for($i=0;$i<$QUESTION_NUMBER;++$i){
			if($user[$i]=="Egal"){$q_no--;continue;}
			if($x[$i]=="Neutral") $res+=$gew[$i]*0.5;//diskutabel: wenn HSG neutral, aber User nicht, 50% übereinstimmung bei der frage setzen
			$res+= $gew[$i] * (($x[$i]==$user[$i])? 1.0 :0.0);
		}
		if($q_no!=0)	$res/=$q_no;
		else		$res=0.5;//disk. , s.o.
		//echo $posKey . ": ". round($res*100,1) . "% <br/>";
		$res_ausgabe[]=array($posKey,round($res*100,1));
			
	}
	
	for($aa=$HSG_NUMBER-1;$aa>0;--$aa){
		for($a=0;$a<$aa;++$a){
			if($res_ausgabe[$a][1]<$res_ausgabe[$a+1][1]){
				$tmp=$res_ausgabe[$a];
				$res_ausgabe[$a]=$res_ausgabe[$a+1];
				$res_ausgabe[$a+1]=$tmp;
			}
		}
	}


	//Ergebnisse der Listen
	echo "<table style='text-align:left;margin-left:70px;' cellpadding='0' cellspacing='0'>";

	for($a=0;$a<$HSG_NUMBER;$a++){
		echo "<tr style='margin:0.5em;'><td><img src='". $bild[$res_ausgabe[$a][0]] ."'/></td><td>" . $res_ausgabe[$a][0] . "</td><td> " . $res_ausgabe[$a][1] . "% </td>";
		echo percentGraph($res_ausgabe[$a][1]);
		echo "</tr>";
		echo "<tr style='height:". ($a==0 ? "1em": "0.5em") ."'><td></td></tr>";//setze bestes Ergebnis durch Leerzeile ab
	}
	echo "</table>";
	

	//Tabelle mit Antworten des Users und der Listen
	echo "<table cellspacing='0' cellpadding='0' style='padding-top:20px;'>";
	echo "<tr><th/><th>Du</th><td/>";//Leerspalte zwischen Benutzer- und HSG-Meinungen
	foreach ($pos as $posKey => $x){
		echo "<th>" . $posKey . "</th>";
	}
	echo "</tr>";

	for($i=0;$i<$QUESTION_NUMBER;++$i){
		echo "<tr>";
		echo "<td style='margin-right:10px;'>".$stichw[$i]."</td>";
		echo VoteToTable($user[$i],""). "<td/>";//Leerspalte, s. Tabellenkopf
		foreach($pos as $posKey => $x){
			$link_stellungnahme=(isset($stellungnahme[$posKey]) && isset($stellungnahme[$posKey][$i]));
			if($link_stellungnahme){
				echo VoteToTableLink($x[$i],"stellungnahmen.php?HSG=".$posKey ."&Frage=".$i);
			}
			else echo VoteToTable($x[$i],"");
		}
		echo "</tr>";
	}
	echo "</table>";
}
else{
	echo "<h2> Frage Nr. ". $step  . "</h2>";

	echo "<p>".($questions[$step-1])."</p>";
?>
<form method="post" action="stupaomat.php">
<?php
	for ($i=1;$i<$step;++$i){ // schleife vorherige Antworten durch, wenn vorhanden
		if(isset($_POST['a'. $i])){
?>
<input type="hidden" name="a<?php echo $i;?>" value="<?php echo htmlspecialchars($_POST['a'.$i]);?>"/>
<?php
		}
	}
?>
<input type="hidden" name="question" value="<?php echo $step+1;?>" />
<input type="image" name="a<?php echo $step;?>" value="Ja" src="Ja.gif"/>
<input type="image" name="a<?php echo $step;?>" value="Nein" src="Nein.gif"/>
<input type="image" name="a<?php echo $step;?>" value="Egal" src="Neutral.gif" />
</form>
<?php }  ?>
<hr/>
<p style="font:6px sans-serif;"><cite>Copyright für Logik/HTML by A.Oster, 2010</cite></p>
</body>
</html>
